Public Class Form1

    Private m_Points As New List(Of Point)

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        m_Points = New List(Of Point)
        Me.Invalidate()
    End Sub

    ' Add a new point.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        m_Points.Add(New Point(e.X, e.Y))
        Me.Invalidate()
    End Sub

    ' Redraw.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)

        ' Draw the convex hull.

        ' Fill all of the points.
        For Each pt As Point In m_Points
            e.Graphics.FillEllipse(Brushes.Cyan, pt.X - 3, pt.Y - 3, 7, 7)
        Next pt

        Dim hull As List(Of Point) = Nothing
        If m_Points.Count >= 3 Then
            ' Get the convex hull.
            hull = MakeConvexHull(m_Points)

            ' Draw.
            ' Fill the non-culled points.
            For Each pt As Point In g_NonCulledPoints
                e.Graphics.FillEllipse(Brushes.White, pt.X - 3, pt.Y - 3, 7, 7)
            Next pt
        End If

        ' Draw all of the points.
        For Each pt As Point In m_Points
            e.Graphics.DrawEllipse(Pens.Black, pt.X - 3, pt.Y - 3, 7, 7)
        Next pt

        If m_Points.Count >= 3 Then
            ' Draw the MinMax quadrilateral.
            Using minmax_pen As New Pen(Color.Red, 1)
                minmax_pen.DashStyle = Drawing2D.DashStyle.Dash
                e.Graphics.DrawPolygon(minmax_pen, g_MinMaxCorners)
            End Using

            ' Draw the culling box.
            Using box_pen As New Pen(Color.Red, 1)
                e.Graphics.DrawRectangle(box_pen, g_MinMaxBox)
            End Using

            ' Draw the convex hull.
            Using hull_pen As New Pen(Color.Blue, 3)
                Dim hull_points(0 To hull.Count - 1) As Point
                hull.CopyTo(hull_points)
                e.Graphics.DrawPolygon(hull_pen, hull_points)
            End Using
        End If
    End Sub
End Class
